KDE 4.7 PyKDE API Reference

- KDE's Python API

# TreeWalker Class Reference

`from PyKDE4.khtml import *`

Namespace: DOM

## Detailed Description

TreeWalker objects are used to navigate a document tree or subtree using the view of the document defined by its whatToShow flags and any filters that are defined for the TreeWalker . Any function which performs navigation using a TreeWalker will automatically support any view defined by a TreeWalker .

Omitting nodes from the logical view of a subtree can result in a structure that is substantially different from the same subtree in the complete, unfiltered document. Nodes that are siblings in the TreeWalker view may be children of different, widely separated nodes in the original view. For instance, consider a Filter that skips all nodes except for Text nodes and the root node of a document. In the logical view that results, all text nodes will be siblings and appear as direct children of the root node, no matter how deeply nested the structure of the original document.

## Methods
| __init__ (self)
| __init__ (self, DOM.TreeWalker other)
DOM.Node | currentNode (self)
bool | expandEntityReferences (self)
DOM.NodeFilter | filter (self)
DOM.Node | firstChild (self)
bool | isNull (self)
DOM.Node | lastChild (self)
DOM.Node | nextNode (self)
DOM.Node | nextSibling (self)
DOM.Node | parentNode (self)
DOM.Node | previousNode (self)
DOM.Node | previousSibling (self)
DOM.Node | root (self)
| setCurrentNode (self, DOM.Node _currentNode)
long | whatToShow (self)

## Method Documentation

__init__ | ( |  | self ) |

__init__ | ( | self, |
|  | DOM.TreeWalker | other
| ) |  |  |

DOM.Node currentNode | ( |  | self ) |

The node at which the TreeWalker is currently positioned. Alterations to the DOM tree may cause the current node to no longer be accepted by the TreeWalker's associated filter. currentNode may also be explicitly set to any node, whether or not it is within the subtree specified by the root node or would be accepted by the filter and whatToShow flags. Further traversal occurs relative to currentNode even if it is not part of the current view, by applying the filters in the requested direction; if no traversal is possible, currentNode is not changed.

DOMException NOT_SUPPORTED_ERR: Raised if an attempt is made to set currentNode to null.

bool expandEntityReferences | ( |  | self ) |

The value of this flag determines whether the children of entity reference nodes are visible to the TreeWalker. If false, they and their descendents will be rejected. Note that this rejection takes precedence over whatToShow and the filter, if any.

To produce a view of the document that has entity references expanded and does not expose the entity reference node itself, use the whatToShow flags to hide the entity reference node and set expandEntityReferences to true when creating the TreeWalker. To produce a view of the document that has entity reference nodes but no entity expansion, use the whatToShow flags to show the entity reference node and set expandEntityReferences to false.

DOM.NodeFilter filter | ( |  | self ) |

The filter used to screen nodes.

DOM.Node firstChild | ( |  | self ) |

Moves the TreeWalker to the first child of the current node, and returns the new node. If the current node has no children, returns null , and retains the current node.

Returns:
  The new node, or null if the current node has no children.

Exceptions from user code Any exceptions raised by a user-written Filter will propagate through.

bool isNull | ( |  | self ) |

DOM.Node lastChild | ( |  | self ) |

Moves the TreeWalker to the last child of the current node, and returns the new node. If the current node has no children, returns null , and retains the current node.

Returns:
  The new node, or null if the current node has no children.

Exceptions from user code Any exceptions raised by a user-written Filter will propagate through.

DOM.Node nextNode | ( |  | self ) |

Moves the TreeWalker to the next node in document order relative to the current node, and returns the new node. If the current node has no next node, returns null , and retains the current node.

Returns:
  The new node, or null if the current node has no next node.

Exceptions from user code Any exceptions raised by a user-written Filter will propagate through.

DOM.Node nextSibling | ( |  | self ) |

Moves the TreeWalker to the next sibling of the current node, and returns the new node. If the current node has no next sibling, returns null , and retains the current node.

Returns:
  The new node, or null if the current node has no next sibling.

Exceptions from user code Any exceptions raised by a user-written Filter will propagate through.

DOM.Node parentNode | ( |  | self ) |

Moves to and returns the parent node of the current node. If there is no parent node, or if the current node is the root node from which this TreeWalker was created, retains the current position and returns null.

Returns:
  The new parent node, or null if the current node has no parent in the TreeWalker's logical view.

Exceptions from user code Any exceptions raised by a user-written Filter will propagate through.

DOM.Node previousNode | ( |  | self ) |

Moves the TreeWalker to the previous node in document order relative to the current node, and returns the new node. If the current node has no previous node, returns null , and retains the current node.

Returns:
  The new node, or null if the current node has no previous node.

Exceptions from user code Any exceptions raised by a user-written Filter will propagate through.

DOM.Node previousSibling | ( |  | self ) |

Moves the TreeWalker to the previous sibling of the current node, and returns the new node. If the current node has no previous sibling, returns null , and retains the current node.

Returns:
  The new node, or null if the current node has no previous sibling.

Exceptions from user code Any exceptions raised by a user-written Filter will propagate through.

DOM.Node root | ( |  | self ) |

The root node of the TreeWalker, as specified when it was created.

setCurrentNode | ( | self, |
|  | DOM.Node | _currentNode
| ) |  |  |

see currentNode

long whatToShow | ( |  | self ) |

This attribute determines which node types are presented via the TreeWalker. The available set of constants is defined in the NodeFilter interface. Nodes not accepted by whatToShow will be skipped, but their children may still be considered. Note that this skip takes precedence over the filter, if any.